
mui.plusReady(function() {
	plus.nativeUI.closeWaiting();
	getInitData();
	initData();
	mui("#login")[0].addEventListener("tap", function(e) {
		//alert(e.target);
		getData();
		if (username && password) {
			saveProperties();
			login();
		} else {
			toast("请输入用户名或密码");
		}

	});
	mui("#switchPersonCustomerApp")[0].addEventListener("tap", function(e) {
		if(plus.os.name == "iOS"){
			var GoodInterJSObj  = plus.ios.newObject("GoodInterJSObj");
    　			plus.ios.invoke(GoodInterJSObj,"GoodInterJSObjBackToRoot:","SwitchPersonCustomerApp");
		}
		else{
			var main = plus.android.runtimeMainActivity();
			var Intent = plus.android.importClass("android.content.Intent");
			var intent = new Intent(main.getIntent());
			intent.setClassName(main, "com.anju.smarthome.ui.main.MainActivity");
			intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			main.startActivity(intent);
		}
	});
	
	mui("#registerButton")[0].addEventListener("tap", function(e) {
		mui.openWindow(
			{
				url: "register.html",
				id: "register.html"
			})
	});
})

function login() {
	ajaxJsonByKey("logincheck", {
		username: username,
		password: password
	}, function(data) {
		saveLoginUser(data);
		openMainView();
	});
}

function getInitData() {
	service_url = getServicePath();
	username = getStorageValueByKey("username");
	//autoLogin = getStorageValueByKey("autoLogin");
	//savePwd = getStorageValueByKey("savePwd");
	//if (savePwd == "1") {
	password = getStorageValueByKey("password");
	//}
}

function initData() {
	if (service_url) {
		mui("#service_url")[0].value = service_url;
	}
	mui("#account")[0].value = username;
	mui("#password")[0].value = password;
//	setAutoLoginSwith(autoLogin);
//	setSavePwdSwith(savePwd);
}

function getData() {
	username = mui("#account")[0].value;
	password = mui("#password")[0].value;
	//autoLogin = isAutoLogin();
	//savePwd = isSavePwd();
}

function saveProperties() {
	saveServiceUrl();
	saveUserName();
	savePassword();
	//saveAutoLogin();
	//saveSavePwd();
}

//function isAutoLogin() {
//	return mui("#autoLogin")[0].classList.contains("mui-active");
//}

//function isSavePwd() {
//	return mui("#savePwd")[0].classList.contains("mui-active");
//}

//function setAutoLoginSwith(isActive) {
//	if (isActive)
//		mui("#autoLogin").switch().toggle();
//}

//function setSavePwdSwith(isActive) {
//	if (isActive)
//		mui("#savePwd").switch().toggle();
//}

function saveServiceUrl() {
	service_url = mui("#service_url")[0].value
	setStorage("service_url", service_url);
}

function saveUserName() {
	setStorage("username", username);
}

function savePassword() {
//	if (savePwd) {
		setStorage("password", password);
//	} else {
//		removeStorageByKey("password");
//	}
}

//function saveAutoLogin() {
//	if (autoLogin) {
//		setStorage("autoLogin", "1");
//	} else {
//		removeStorageByKey("autoLogin");
//	}
//}

//function saveSavePwd() {
//	if (savePwd) {
//		setStorage("savePwd", "1");
//	} else {
//		removeStorageByKey("savePwd");
//	}
//}
function saveLoginUser(data){
	console.log(JSON.stringify(data));
	setStorage("loginUser",JSON.stringify(data));
}
