function PopWin(options)
{
	this.template = new Template();
	var div = document.createElement("div");
	addClass(div, "popoverbg");
	//addClass(div, "popoverbg-active");
	document.querySelector("body").appendChild(div);
	this.mask = div;
}
function Poptip(contentID)
{
	PopOver.init();
	var div = document.getElementById(contentID);
	var content = "<div style='text-align: center'>没有数据！</div>";
	if(div)
		content = div.innerHTML;
	PopOver.show("", content);
}
var PopOver =
{
	template: null,
	mask: null,
	win: null,
	init: function()
	{
		//遮罩
		if(!PopOver.mask)
		{
			PopOver.mask = document.createElement("div");
			addClass(PopOver.mask, "popoverbg");
			//addClass(div, "popoverbg-active");
			document.querySelector("body").appendChild(PopOver.mask);
			PopOver.mask.addEventListener("tap", function(){
				setTimeout(function(){
					PopOver.hide();
				}, 500);
			});
		}
		
		//窗口外框
		if(!PopOver.win)
		{
			PopOver.win = document.createElement("div");
			addClass(PopOver.win, "am-popover");
			document.querySelector("body").appendChild(PopOver.win);
		}
		
		if(!PopOver.template)
			PopOver.template = new Template();
	},
	show: function(title, content, buttons, callback, init)
	{
		var html = "";
		
		if(title)
			html += "<h3 class=\"am-popover-title\">" + title + "</h3>";
		html += "<div class=\"am-popover-content\">";
		html += content;
		html += "</div>";
		if(buttons && buttons.length && buttons.length > 0)
		{
			var style = "";
			//if(buttons.length % 2 == 0)
			//	style = "display: inline; width: 45%; margin: 2px";
			html += "<div class=\"am-popover-footer\">";
			for(var i = 0; i < buttons.length; i++)
			{
				if(buttons[i].style)
					style = buttons[i].style;
				else
					style = "";
				//alert(style);
				html += "<button button_index=\"" + i + "\" class=\"mui-btn mui-btn-primary sure_btn\" style=\"" + style + 
						"\">" + buttons[i].text + "</button>";
			}
			html += "</div>";
		}
		PopOver.win.innerHTML = html;
		setTimeout(function(){
			var b = document.querySelectorAll(".sure_btn");
			if(b)
			{
				for(var i = 0; i < b.length; i++)
					b[i].addEventListener("tap", function(e){
						//toast(e.target.attributes["button_index"].name);
						//toast(e.target.attributes["button_index"].value);
							var close = true;
							var index = parseInt(e.target.attributes["button_index"].value);
							if(index >= 0 && index < buttons.length)
								if(callback)
									close = callback(buttons[index]);
							if(close)
								setTimeout(function(){PopOver.hide()}, 300);
					});
			}
			if(init)
			{
				init(PopOver.win);
			}
		}, 300);
		addClass(PopOver.mask, "popoverbg-active");
		addClass(PopOver.win, "am-popover-active");
	},
	singleSelect: function(title, buttons, callback)
	{
		var html = "";
		if(title)
			html += "<h3 class=\"am-popover-title\">" + title + "</h3>";
		html += "<div class=\"am-popover-content\">";
		//html += content;
		var w = document.documentElement.clientHeight - 100;
		html += '<ul class="mui-table-view" style="max-height: ' + w + 'px; overflow: auto">';
		for(var i = 0; i < buttons.length; i++)
		{
			//buttons.push({title: data[i][options.textName]});
			html += '<li class="mui-table-view-cell" data-index="' + i + '" id="';
			html += "liPopItem_" + i;
			html +=  '" style="width: 100%; overflow: hidden">';
			html += buttons[i].title;
			html += '</li>';
		}
		html += "</ul>";
		html += "</div>";
		PopOver.win.innerHTML = html;
		
		setTimeout(function(){
			var b = document.querySelectorAll('li[id^="liPopItem_"]');
			if(b)
			{
				for(var i = 0; i < b.length; i++)
					b[i].addEventListener("tap", function(e){
						var close = true;
						var index = parseInt(e.target.dataset.index);
						if(index >= 0 && index < buttons.length)
						{
							//console.log(JSON.stringify(buttons[index]));
							if(callback)
								callback(buttons[index]);
						}
						if(close)
							setTimeout(function(){PopOver.hide()}, 300);
					});
			}
		}, 300);
		
		addClass(PopOver.mask, "popoverbg-active");
		addClass(PopOver.win, "am-popover-active");
	},
	hide: function()
	{
		removeClass(PopOver.win, "am-popover-active");
		removeClass(PopOver.mask, "popoverbg-active");
	}
};

var PopOver2 =
{
	template: null,
	mask: null,
	win: null,
	init: function()
	{
		//遮罩
		if(!PopOver2.mask)
		{
			PopOver2.mask = document.createElement("div");
			addClass(PopOver2.mask, "popoverbg");
			//addClass(div, "popoverbg-active");
			document.querySelector("body").appendChild(PopOver2.mask);
			PopOver2.mask.addEventListener("tap", function(){
				setTimeout(function(){
					PopOver2.hide();
				}, 500);
			});
		}
		
		//窗口外框
		if(!PopOver2.win)
		{
			PopOver2.win = document.createElement("div");
			addClass(PopOver2.win, "am-popover");
			document.querySelector("body").appendChild(PopOver2.win);
		}
		
		if(!PopOver2.template)
			PopOver2.template = new Template();
	},
	show: function(title, content, buttons, callback, init)
	{
		var html = "";
		if(title)
			html += "<h3 class=\"am-popover-title\">" + title + "</h3>";
		html += "<div class=\"am-popover-content\">";
		html += content;
		html += "</div>";
		if(buttons && buttons.length && buttons.length > 0)
		{
			var style = "";
			//if(buttons.length % 2 == 0)
			//	style = "display: inline; width: 45%; margin: 2px";
			html += "<div class=\"am-popover-footer\">";
			for(var i = 0; i < buttons.length; i++)
			{
				if(buttons[i].style)
					style = buttons[i].style;
				else
					style = "";
				//alert(style);
				html += "<button button_index=\"" + i + "\" class=\"mui-btn mui-btn-primary sure_btn\" style=\"" + style + 
						"\">" + buttons[i].text + "</button>";
			}
			html += "</div>";
		}
		PopOver2.win.innerHTML = html;
		
		setTimeout(function(){
			var b = document.querySelectorAll(".sure_btn");
			if(b)
			{
				for(var i = 0; i < b.length; i++)
					b[i].addEventListener("tap", function(e){
						//toast(e.target.attributes["button_index"].name);
						//toast(e.target.attributes["button_index"].value);
							var close = true;
							var index = parseInt(e.target.attributes["button_index"].value);
							if(index >= 0 && index < buttons.length)
								if(callback)
									close = callback(buttons[index]);
							if(close)
								setTimeout(function(){PopOver2.hide()}, 300);
					});
			}
			if(init)
			{
				init(PopOver2.win);
			}
		}, 300);
		
		addClass(PopOver2.mask, "popoverbg-active");
		addClass(PopOver2.win, "am-popover-active");
	},
	singleSelect: function(title, buttons, callback)
	{
		var html = "";
		if(title)
			html += "<h3 class=\"am-popover-title\">" + title + "</h3>";
		html += "<div class=\"am-popover-content\">";
		//html += content;
		var w = document.documentElement.clientHeight - 100;
		html += '<ul class="mui-table-view" style="max-height: ' + w + 'px; overflow: auto">';
		for(var i = 0; i < buttons.length; i++)
		{
			//buttons.push({title: data[i][options.textName]});
			html += '<li class="mui-table-view-cell" data-index="' + i + '" id="';
			html += "liPopItem_" + i;
			html +=  '" style="width: 100%; overflow: hidden">';
			html += buttons[i].title;
			html += '</li>';
		}
		html += "</ul>";
		html += "</div>";
		PopOver2.win.innerHTML = html;
		
		setTimeout(function(){
			var b = document.querySelectorAll('li[id^="liPopItem_"]');
			if(b)
			{
				for(var i = 0; i < b.length; i++)
					b[i].addEventListener("tap", function(e){
						var close = true;
						var index = parseInt(e.target.dataset.index);
						if(index >= 0 && index < buttons.length)
						{
							//console.log(JSON.stringify(buttons[index]));
							if(callback)
								callback(buttons[index]);
						}
						if(close)
							setTimeout(function(){PopOver2.hide()}, 300);
					});
			}
		}, 300);
		
		addClass(PopOver2.mask, "popoverbg-active");
		addClass(PopOver2.win, "am-popover-active");
	},
	hide: function()
	{
		removeClass(PopOver2.win, "am-popover-active");
		removeClass(PopOver2.mask, "popoverbg-active");
	}
};

//options:title, cancel, valueName, textName
function addData(buttons, data, field, pre)
{
	pre = pre || "";
	data.title = pre + data[field];
	buttons.push(data);
	//console.log(JSON.stringify(data));
	//console.log(JSON.stringify(data.children));
	if(data.children)
	{
		for(var i = 0; i < data.children.length; i++)
		{
			addData(buttons, data.children[i], field, pre + "&nbsp;&nbsp;")
		}
	}
}
function showSingleSelected(options, data, callback)
{
	if(!data || data.length <= 0)
		return;
	var buttons = [];
	for(var i = 0; i < data.length; i++)
	{
		//data[i].title = data[i][options.textName];
		//buttons.push(data[i]);
		addData(buttons, data[i], options.textName, "")
	}
	PopOver.init();
	PopOver.singleSelect(options.title, buttons, callback);
}
function getSingleSelected(url, options, callback)
{
	if(!document.SingleData)
		document.SingleData = {};
	var data = "";//document.SingleData[url];
	if(data)
	{
		showSingleSelected(options, data, callback);
	}
	else
	{
		ajax(getServicePath(url), {
			data: "",
			callback: function(data, userdata){
				var rows = data.rows;
				if(!rows)
					rows = data;
				 //document.SingleData[url] = rows;
				 showSingleSelected(options, rows, callback);
			}
		});
	}
}

var CustomerSystemTypeList = [];

function getCustomerSystemType_chentao(customerid, ele, callback, type) {
	getSingleSelectedPopover(ele, {
			urlkey: "getCustomerSystemList",
			listoryData: CustomerSystemTypeList[customerid],
			requestData: {
				customerid: customerid
			},
			title: "请选择报修系统：",
			datatitle: "systemname",
			no_data_msg: "暂无您的系统信息"
		}, function(item) {
			if (!type || type == 1) {
				if (item)
					callback([item["systemid"], item["systemtypeid"]]);
				else
					callback(null);
			} else
				callback(item);
		},
		function(data) {
			CustomerSystemTypeList[customerid] = data;
		});
}
function getCustomerSystemType(customerid, ele, callback, type) {
	getSingleSelectedPopover(ele, {
			urlkey: "getCustomerSystemList",
			listoryData: CustomerSystemTypeList[customerid],
			requestData: {
				customerid: customerid
			},
			title: "请选择报修系统：",
			datatitle: "systemisexpire",
			no_data_msg: "暂无您的系统信息",
			cancel:"取消"
		}, function(item) {
			if (!type || type == 1) {
				if (item)
					callback([item["systemid"], item["systemtypeid"]]);
				else
					callback(null);
			} else
				callback(item);
		},
		function(data) {
			CustomerSystemTypeList[customerid] = data;
		});
}
var sexList;

function getSexList(ele, callback, type) {
	getSingleSelectedPopover(ele, {
		urlkey: "getSexList",
		listoryData: sexList,
		title: "请选择性别：",
		datatitle: "detailname"
	}, function(item) {
		if (!type || type == 1) {
			if (item)
				callback([item["detailid"]]);
			else
				callback(null);
		} else
			callback(item);
	}, function(data) {
		sexList = data;
	});
}

var EquipmentList = [];

function getEquipmentListBySystemId(systemid, ele, callback) {
	getCheckBoxListPopover(ele, {
		urlkey: "getEquipmentListBySystemId",
		listoryData: EquipmentList[systemid],
		requestData: {
			systemid: systemid
		},
		title: "选择设备信息",
		buttons: {
			sure: "确定"
		},
		datatitle: "equipmentname",
		no_data_msg: "无客户设备信息"
	}, function(data) {
		callback(data);
	}, function(data) {
		EquipmentList[systemid] = data;
	});
}

function getSingleSelectedPopover(ele, options, callback, returnData) {
	if (options.listoryData && options.listoryData.length > 0) {
		actionSheet({
			title: options.title,
			cancel: options.cancel,
			data: options.listoryData,
			datatitle: options.datatitle,
			getSelectedItem: function(item) {
				if (item) {
					ele.value = item[options.datatitle];
				} else {
					ele.value = "";
				}
				callback(item);
			}
		});
	} else {
		ajaxJsonByKey(options.urlkey, options.requestData,
			function(data) {
				returnData(data);
				if (data.length > 0) {
					actionSheet({
						title: options.title,
						cancel: options.cancel,
						data: data,
						datatitle: options.datatitle,
						getSelectedItem: function(item) {
							if (item) {
								ele.value = item[options.datatitle];
							} else {
								ele.value = "";
							}
							callback(item);
						}
					});
				}
				else if(options.no_data_msg)
					toast(options.no_data_msg);
			});
	}
}

/**
 * @param {Object} callback
 * @param {Object} type  1:(yyyy-MM-dd)  2:(yyyy-MM-dd hh:mm:ss) 3:(yyyy-MM-dd hh:mm) 4(hh:mm:ss)
 */

function getTime(ele, type) {
	if (!type)
		type = 1;
	if (type >= 4) {
		plus.nativeUI.pickTime(function(e) {
			ele.value = e.date.pattern("HH:mm:ss");
		}, function(e) {
			ele.value = null;
		});
	} else {
		plus.nativeUI.pickDate(function(e) {
			var dateStr = e.date.pattern("yyyy-MM-dd");
			if (type == 1) {
				ele.value = dateStr;
			} else {
				plus.nativeUI.pickTime(function(e) {
					if (type == 2)
						ele.value = dateStr + " " + e.date.pattern("HH:mm:ss");
					else
						ele.value = dateStr + " " + e.date.pattern("HH:mm");
				}, function(e) {
					ele.value = null;
				});
			}
		}, function(e) {
			ele.value = null;
		});
	}
}

function actionSheet(data, indexlist) {
	if (!indexlist)
		indexlist = [];
	getTempData(data.data, indexlist, function(tempdata) {
		if (tempdata) {
			getButtons(tempdata, data.datatitle, indexlist, function(buttons) {
				plus.nativeUI.actionSheet({
					title: data.title,
					cancel: data.cancel,
					buttons: buttons
				}, function(e) {
					if (e.index > 0) {
						if (e.index > tempdata.length) {
							indexlist.pop();
						} else {
							indexlist.push(e.index - 1);
						}
						actionSheet(data, indexlist);
					} else if (e.index == 0) {
						getSelectedItem(data.data, indexlist, data.getSelectedItem);
					} else {
						data.getSelectedItem(null);
					}
				});
			});
		} else {
			getSelectedItem(data.data, indexlist, data.getSelectedItem);
		}
	});
}

function getTempData(data, indexlist, callback, index) {
	var str = "";
	if (indexlist) {
		for (var i = 0; i < indexlist.length; i++) {
			if (str != "")
				str += ",";
			str += indexlist[i];
		}
	}
	if (indexlist.length == 0 || index == indexlist.length) {
		callback(data);
	} else {
		if (!index)
			index = 0;
		getTempData(data[indexlist[index]].children, indexlist, callback, ++index);
	}
}

function getSelectedItem(data, indexlist, callback, index) {
	if (indexlist.length == 0)
		callback(null);
	else {
		if (!index)
			index = 0;
		if (index + 1 == indexlist.length)
			callback(data[indexlist[index]])
		else
			getSelectedItem(data[indexlist[index]].children, indexlist, callback, ++index);
	}
}

function getButtons(data, title, indexlist, callback) {
		var buttons = [];
		for (var i = 0; i < data.length; i++) {
			buttons[i] = {
				title: data[i][title]
			}
		}
		if (indexlist.length > 0)
			buttons[buttons.length] = {
				title: "返回上级"
			};
		callback(buttons);
	}
	/**       
	 * 对Date的扩展，将 Date 转化为指定格式的String
	 * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q) 可以用 1-2 个占位符
	 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
	 * eg:
	 * (new Date()).pattern("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
	 * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04
	 * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04
	 * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04
	 * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18
	 */
Date.prototype.pattern = function(fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份           
		"d+": this.getDate(), //日           
		"h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时           
		"H+": this.getHours(), //小时           
		"m+": this.getMinutes(), //分           
		"s+": this.getSeconds(), //秒           
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度           
		"S": this.getMilliseconds() //毫秒           
	};
	var week = {
		"0": "/u65e5",
		"1": "/u4e00",
		"2": "/u4e8c",
		"3": "/u4e09",
		"4": "/u56db",
		"5": "/u4e94",
		"6": "/u516d"
	};
	if (/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	if (/(E+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "/u661f/u671f" : "/u5468") : "") + week[this.getDay() + ""]);
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
}

function getCheckBoxListPopover(ele, options, callback, returnData) {
	if (options.listoryData && options.listoryData.length > 0) {
		actionCheckBoxList(ele, options.title, options.listoryData, options.buttons.sure, options.datatitle, callback);
	} else {
		ajaxJsonByKey(options.urlkey, options.requestData,
			function(data) {
				returnData(data);
				if (data.length > 0) {
					actionCheckBoxList(ele, options.title, data, options.buttons.sure, options.datatitle, callback);
				}
				else if(options.no_data_msg)
					toast(options.no_data_msg);
			});
	}
}

function actionCheckBoxList(ele, title, data, cancel, datatitle, callback) {
	var div2 = initCheckBoxListPopover(title, data, cancel, datatitle);
	addClass(div2, "am-popover-active");
	if (document.querySelector(".popoverbg") && document.querySelector(".popoverbg").length > 0) {
		addClass(document.querySelector(".popoverbg"), "popoverbg-active");
	} else {
		var div = document.createElement("div");
		addClass(div, "popoverbg");
		addClass(div, "popoverbg-active");
		document.querySelector("body").appendChild(div);
		document.querySelector(".am-popover-content").style.maxHeight = document.documentElement.clientHeight - 120 + "px";
	}
	addCheckBoxListPopoverListener(div2,data, ele, datatitle, callback);
}

function initCheckBoxListPopover(title, data, cancel, datalabel) {
	var div = document.createElement("div");
	addClass(div, "am-popover");
	var html = "<h3 class=\"am-popover-title\">" + title + "</h3>";
	html += "<div class=\"am-popover-content\">";
	html += "<form class=\"mui-input-group\">";
	for (var i = 0; i < data.length; i++) {
		html += "<div class=\"mui-input-row mui-checkbox\">";
		html += "<label>" + data[i][datalabel] + "</label>";
		html += "<input type=\"checkbox\" " + (data[i]["checked"] ? "checked" : "") + "></div>";
	}
	html += "</form>";
	html += "</div>";
	html += "<div class=\"am-popover-footer\"><button class=\"sure_btn\">" + cancel + "</button></div>";
	div.innerHTML = html;
	document.querySelector("body").appendChild(div);
	return div;
}

function addCheckBoxListPopoverListener(div,data, ele, datatitle, callback) {
	document.querySelector(".popoverbg-active").addEventListener("tap", function() {
		removeClass(div, "am-popover-active");
		setTimeout(function() {
			removeClass(document.querySelector(".popoverbg-active"), "popoverbg-active");
			document.body.removeChild(document.querySelector(".popoverbg"));
		}, 300);
	})
	div.querySelector(".sure_btn").addEventListener("tap", function() {
		removeClass(div, "am-popover-active");
		var inputs = div.querySelector(".am-popover-content").querySelectorAll("input");;
		var result = [];
		var str = "";
		for (var i = 0; i < inputs.length; i++) {
			if (inputs[i].checked) {
				if (str != "")
					str += ",";
				str += data[i][datatitle];
				result.push(data[i]);
			}
		}
		ele.value = str;
		callback(result);
		setTimeout(function() {
			removeClass(document.querySelector(".popoverbg-active"), "popoverbg-active");
			if (document.querySelector(".popoverbg"))
				document.body.removeChild(document.querySelector(".popoverbg"));
		}, 300);
	})
}

var catalogList = [];

function getCatalogList(ele, callback, type) {
	getSingleSelectedPopover(ele, {
			urlkey: "getCatalogList",
			listoryData: catalogList,
			requestData: {
				
			},
			title: "请选择服务目录：",
			no_data_msg: "暂无服务目录",
			datatitle: "catalogname",
			cancel:"取消"
		}, function(item) {
			if (!type || type == 1) {
				if (item)
					callback([item["catalogid"]]);
				else
					callback(null);
			} else
				callback(item);
		},
		function(data) {
			catalogList = data;
		});
		
}