mui.plusReady(function() {
	mui("#getValidateCode")[0].addEventListener("tap", function(e) {
		var phoneNum = mui("#phoneNum")[0].value;
		if (isPhoneAvailable(phoneNum)){
			ajaxJsonByKey("getValidateCode", {
				phoneNum: phoneNum
			}, function(data) {
				toast(data.result);
				settime(e.target);
			});
		}
		else{
			alert("请输入正确的手机号");
		}
		
	});
	
	mui("#register")[0].addEventListener("tap", function(e) {
		var phoneNum = mui("#phoneNum")[0].value;
		var validateCode = mui("#validateCode")[0].value;
		if (validate(phoneNum,validateCode)){
			ajaxJsonByKey("validateCodeLoginCheck", {
				phoneNum: phoneNum,
				validateCode: validateCode,
				loginType: "clientAppValidateLogin"
			}, function(data) {
				saveLoginUser(data);
				console.error(JSON.stringify(data));
				var isAlterPassword = data.isalterpassword;
				if(isAlterPassword == 1){
					setTimeout(function(){
						mui.openWindow({
							url: "initPasswordAlter.html",
						});
					}, 300);
				}
				else{
					openMainView();
				}
				setTimeout(function(){
					plus.webview.getWebviewById("register.html").close();
				},500)
			});
		}
		else{
			alert("请输入手机号和验证码");
		}
		
	});
})

var countdown = 60;
function settime(obj) {
    if (countdown == 0) {
        obj.removeAttribute("disabled");
        obj.innerHTML="发送验证码";
        countdown = 60;
        return;
    } else {
        obj.setAttribute("disabled", true);
        
        obj.innerHTML=countdown + "s";
        countdown--;
    }
	setTimeout(function() {
    	settime(obj) }
    ,1000)
}

/**
 * 判断是否为有效手机号
 * @param {Object} str
 */
function isPhoneAvailable(str) {
    var myreg=/^[1][3,4,5,7,8][0-9]{9}$/;
    if (!myreg.test(str)) {
        return false;
    } else {
        return true;
    }
}

function validate(phoneNum,validateCode) {
    if (isEmpty(phoneNum) && isEmpty(validateCode)) {
        return false;
    } else {
        return true;
    }
}

//判断字符是否为空的方法
function isEmpty(obj){
    if(typeof obj == "undefined" || obj == null || obj == ""){
        return true;
    }else{
        return false;
    }
}
