var service_url_file_path = "../data/url/url.json";
var urldata;

function ajaxJsonByKey(key, requestdata, callback, errorcallback, error) {
	if (key == "logincheck" || key == "validateCodeLoginCheck") {
		var ci = plus.push.getClientInfo();
//		alert(ci+"ci1");
//		alert(JSON.stringify(ci)+"ci2")
		if (ci)
			requestdata.clientid = ci.clientid;
	}
	if (urldata) {
		ajaxJson(getServicePath(urldata[key]), requestdata, callback, errorcallback, error);
	} else {
		ajax(service_url_file_path, {
			success: function(data) {
				urldata = data;
				ajaxJson(getServicePath(data[key]), requestdata, callback, errorcallback, error);
			},
			error: function(xhr, type, errorThrown) {
				plus.nativeUI.closeWaiting();
				toast("type:" + type + "   " + errorThrown);
			}
		});
	}
}

function ajaxJson(url, data, callback, errorcallback, error) {
	ajax(url, {
		data: data,
		callback: callback,
		errorcallback: errorcallback,
		error: error
	});
}

function ajaxLoadHtml(url, documentid, callback) {
	ajax(url, {
		dataType: "text",
		success: function(data) {
			mui("#" + documentid)[0].innerHTML = data;
			clearInfos();
			if (callback) {
				callback();
			};
			setContentHeight();
		},
		error: function(xhr, type, errorThrown) {
			toast("type:" + type + "   " + errorThrown);
		}
	});
}
/**
 * @param url 
 * @param options  参数对象
 */
function ajax(url, options) {
	options = options || {};
	var data = options.data;
	if(data)
	{
		if(typeof data == "object")
			data.IsCustomerVersion = 1;
		else
			data += "&IsCustomerVersion=1";
	}
	else
		data = "IsCustomerVersion=1";
	mui.ajax(url, {
		data: data,
		dataType: options.dataType || "json",
		type: options.type || "post",
		timeout: options.timeout || 10000, //超时时间设置为10秒；
		success: function(data) {
			if (options.success) {
				options.success(data);
			} else {
				if (!options.dataType || options.dataType.toLowerCase() == "json") {
					if (data.type && data.type == "success") {
						if (options.callback)
							options.callback(data.data, options.userdata);
					} else {
						if (options.errorcallback)
							options.errorcallback(data.data, options.userdata);
						else
							alert(data.data);
					}
				} else if (options.callback)
					options.callback(data, options.userdata);
			}
		},
		error: function(xhr, type, errorThrown) {
			if (type == "timeout")
				alert('在规定的时间内服务器没有响应！');
			else if (type == "parsererror")
				alert('数据解析错误：\n' + errorThrown + "\n返回的数据：\n" + xhr.response);
			else if (type == "abort") {
				toast('已掉线！');
			} else if (type == "error" && errorThrown == "Not Found")
				toast("请检测访问的网络路径");
			else {
				alert("type:" + type + "   " + errorThrown + "           " + xhr.response);
			}
			if (options.error) {
				options.error(xhr, type, errorThrown);
			}
		}
	});
}