window.onload = function() {
	//从服务器获取数据
	//注意：若为ajax请求，则需将如下代码放在处理完ajax响应数据之后；
	mui.plusReady(function() {
		showWebview();
		setHomePageContent();
		
		
//		setRepairMainContent();
		tabControl();
//		var systemHeight = plus.navigator.getStatusbarHeight();
//		plus.webview.currentWebview().setStyle({top:systemHeight})	
		// 监听点击消息事件
		plus.push.addEventListener( "click", function( msg ) {
		    var data;
		    if(msg.aps)
		    	data = JSON.parse(msg.aps.category);
		    else
		    	data = JSON.parse(msg.payload);
		    var Redirect = data.Redirect;
		    //alert(JSON.stringify(data));
		    var url = "";
		    if(Redirect == "Notice")
		    	url = "my/noticeview.html";
		    else if(Redirect == "Contract")
		    	url = "ContractInfo.html"
		    else
		    {
		    	var id = parseInt(data.DispatchID);
		    	if(id < 0)
		    	{
		    		url = "my/noticeview.html";
		    		id = -id;
		    	}
		    }
	    	OnWorkBillDetail(data.DispatchID, url);
		}, true);
		// 监听在线消息事件
		plus.push.addEventListener( "receive", function( msg ) {
		    //alert( JSON.stringify(msg));
		    var data;
		    if(msg.aps)
		    	data = JSON.parse(msg.aps.category);
		    else
		    	data = JSON.parse(msg.payload);
		    var Redirect = data.Redirect;
		    //alert(JSON.stringify(data));
		    var url = "";
		    if(Redirect == "Notice")
		    	url = "assitant/noticeview.html";
		    else if(Redirect == "Contract")
		    	url = "ContractInfo.html"
		    else
		    {
		    	var id = parseInt(data.DispatchID);
		    	if(id < 0)
		    	{
		    		url = "assitant/noticeview.html";
		    		id = -id;
		    	}
		    }
	    	OnWorkBillDetail(data.DispatchID, url);
		}, true);
		
		if(plus.os.name == "iOS")
		{
			var btnClose = mui("#dvExit")[0].querySelectorAll("li")[1];
			btnClose.style.display = "none";
		}
		else{
			getVersion();
		}
		
		mui("#switchPersonCustomerApp")[0].addEventListener("tap", function(e) {
			if(plus.os.name == "iOS"){
				var GoodInterJSObj  = plus.ios.newObject("GoodInterJSObj");
	    　			plus.ios.invoke(GoodInterJSObj,"GoodInterJSObjBackToRoot:","SwitchPersonCustomerApp");
			}
			else{
				var main = plus.android.runtimeMainActivity();
				var Intent = plus.android.importClass("android.content.Intent");
				var intent = new Intent(main.getIntent());
				intent.setClassName(main, "com.anju.smarthome.ui.main.MainActivity");
				intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
				main.startActivity(intent);
			}
		});
//		wjdc();
	});
};
function wjdc(){
	var btnArray = ['确定', '取消'];
		mui.confirm("邀请您进行企业安全调查","安全调查",btnArray,function(e){
			if (e.index == 0) {
				mui.openWindow({
					url: "evaluating.html",
					id: "evaluating.html"
				});
			} else {
				toast("退出问卷调查");
			}
		})
}
function getVersion(){
	var nowVersion = plus.runtime.version;
	var option = {
		isCustomerVersion:1
	}
	ajaxJson(getServicePath("mobile/getVersion.html"),option,function(data){
		if(data.result == "error"){
			toast("当前APP版本不合法！");
		}
		else if(data.result == "ok"){
//			if(data.paramvalue != nowVersion){
//				var btnArray = ['否', '是'];
//				mui.confirm("检查到有新版本，是否更新？","更新提示",btnArray,function(e){
//					if (e.index == 1) {
//						plus.runtime.openURL("http://shouji.baidu.com/software/11513567.html");
//					} else {
//						toast("取消更新");
//					}
//				})
//			}
//			else{
//				toast("当前为最新版本");
//			}
		}
	});
}
//点击某一条，跳转到明细页面
function OnWorkBillDetail(id, page)
{
	var win = plus.webview.getWebviewById( "WorkBillDetail.html" );
	if(win)
	{
		win.close();
	}
	page = "_www/view/" + (page || "myrepairs/DispatchBillDetail.html");
	mui.openWindow({
		url: page,
		id: "WorkBillDetail.html",
		extras:{
		    DispatchID: id
		}
	});
}
function setBannerUrl(){
	var url = getServicePath("/mobile/AppManager/Banner/getList.html");
	mui.ajax(url, {
		data: {},
		dataType: "json",
		type: "post",
		timeout: 10000, //超时时间设置为10秒；
		success: function(data) {
			for(var i=0;i<data.length;i++){
				index = data[i].sortno;
				mui("#bannera"+index)[0].href = data[i].link;
				mui("#bannerimg"+index)[0].src = service_url + data[i].location + data[i].attatchid +  data[i].fileext;
			}
			mui("#bannera0")[0].href = data[3].link;
			mui("#bannerimg0")[0].src = service_url + data[3].location + data[3].attatchid +  data[3].fileext;
			mui("#bannera5")[0].href = data[0].link;
			mui("#bannerimg5")[0].src = service_url + data[0].location + data[0].attatchid +  data[0].fileext;
			
		}
	});
}
function setHomePageContent(){
	mui("#lbTitle")[0].innerHTML = "首页";
	mui("#lbback")[0].style.display="none";
	mui("#mapButton")[0].style.display = "block";
	mui("#switchButton")[0].style.display = "none";
	mui("#navPage")[0].style.display = "none";
	mui("#bar_tabs")[0].style.display="";
	ajaxLoadHtml("homePage.html", "content", function() {
		//图片轮播开始--htt
			mui.init({
				swipeBack:true //启用右滑关闭功能
			});
			var slider = mui("#slider");
			slider.slider({
				interval: 5000
			});
		//图片轮播结束--
		mui("#repair_online")[0].addEventListener("tap", function() {
			customerid = JSON.parse(getStorageValueByKey("loginUser"))["customerid"];
			if(customerid == 0 || customerid == "" || customerid == undefined){
				alert("请完成企业注册");
			}
			else{
				plus.nativeUI.showWaiting("正在加载...");
			setTimeout(function() {
				plus.nativeUI.closeWaiting();
//				setRepairOnLineContent();
				openRepairOnline();
			}, 500);
			}
			
		});
		customerid = JSON.parse(getStorageValueByKey("loginUser"))["customerid"];
		ajaxJsonByKey('getRecentRepairs',{
			customerID: customerid
		},function(data){	
			var recentRepairsHtml = '<ul class="mui-table-view" style="margin-top: 0px;">';
			mui.each(data,function(index,element){
//				console.log(JSON.stringify(element));
				if(!isNaN(element)){
//					console.log('total：'+element);
				}
				else{
					mui.each(element,function(i,item){
						recentRepairsHtml += '<li class="mui-table-view-cell mui-media" onclick="OnWorkBillDetail(';
						recentRepairsHtml += item.dispatchid;
						recentRepairsHtml += ')"><div class="columns cate_show"><dl class="col-dl"><dt class="h2">';
						recentRepairsHtml += item.repairscode;
						recentRepairsHtml += '<span class="value mui-pull-right state">';
						recentRepairsHtml += item.billtypename;
						recentRepairsHtml += '</span></dt><dd class="gray">申请人<span class="value mui-pull-right">';
						recentRepairsHtml += item.repairman;
						recentRepairsHtml += '</span></dd><dd class="gray">申请时间<span class="value mui-pull-right">';
						recentRepairsHtml += item.repairstime;
//						recentRepairsHtml += '</span></dd><dd class="gray">报修系统<span class="value mui-pull-right">';
//						recentRepairsHtml += item.systemname;
						recentRepairsHtml += '</span></dd><dd class="gray">服务内容：</dd><dd class="gray"><div style="margin-left: 10px;color: #929292;font-style: italic;">';
						recentRepairsHtml += item.repairscontent;
						recentRepairsHtml += '</div></dd></dl></div></li>';
					})
				}
				
			})
			recentRepairsHtml += '</ul>';
			mui('#recentRepairs')[0].innerHTML = recentRepairsHtml;
//			deptPhone = JSON.parse(getStorageValueByKey("loginUser"))["deptphone"];
//			if(deptPhone == null || deptPhone == ""){
//				deptPhone = "4008876119";
//			}
			/**获取主服务人员（大客户经理电话）start----htt（taotao）--**/
			var getMarsterPhoneUrl = "/mobile/Customer_Basic_Info/View.html?"+JSON.parse(getStorageValueByKey("loginUser"))["customerid"]+"-";
			mui.ajax(getServicePath(getMarsterPhoneUrl), {
					dataType: "json",
					type: "post",
					timeout: 10000, //超时时间设置为10秒；
					success: function(data) {
						var marsterPhone = data.data.masterphone;
						if(marsterPhone == null || marsterPhone == ""){
							marsterPhone = "4008876119";
						}	
						document.getElementById('oneKeyRepair').setAttribute("href","tel:"+marsterPhone);
					}
				}
			);
			
			/**获取主服务人员（大客户经理电话）end----htt（taotao）--**/
			
//			document.getElementById('oneKeyRepair').setAttribute("href","tel:"+deptPhone);
		});
		})
	setBannerUrl();
	setContentHeight();
}
function setAssitant()
{
	//mui("#navPage")[0].style.display = "none";
	mui("#lbTitle")[0].innerHTML = "法律法规";
	//setContentHeight();

	ajaxLoadHtml("assitant.html", "content", function() {
		OnInitAssitant();
		setContentHeight();
	});
	//setReturnCallback(null);
	//mui("#imgAsstiant")[0].src = "../images/asstiant_active.png";
}
function setMarketContent(){
	mui("#lbTitle")[0].innerHTML = "增值服务";
	mui("#mapButton")[0].style.display = "block";
	mui("#switchButton")[0].style.display = "none";
	ajaxLoadHtml("market.html", "content", function() {
		OnSearchGooditsSparePart();
	});
}
function tabControl() {
	mui(".mui-tab-item").each(function(index, obj) {
		obj.addEventListener("tap", function(event) {
			if (obj.id == "tab-item-assitant") {
				setAssitant();
			} else if (obj.id == "tab-item-market") {
				setMarketContent();
			}else if (obj.id == "tab-item-homePage") {
				setHomePageContent();
			} else if (obj.id == "tab-item-mine") {
				setMineContent();
			} else if (obj.id == "tab-item-knowledge") {
				setKnowledge();
			}
		});
	});
}
function OnCustomerRegisterInfo(page)
{
	setTimeout(function(){
		mui.openWindow({
			url: "my/" + page,
			id: page
		});
	}, 300);
}
function OnMyInfoDetail(page)
{
	setTimeout(function(){
		mui.openWindow({
			url: "my/" + page,
			id: page,
			extras:{
			    myinfo: document.myinfo
			}
		});
	}, 300);
}
function OnMyExit()
{
	mui('#dvExit').popover('toggle');
	
	var obj = mui('#dvExit')[0];
	var w = document.documentElement.clientWidth;
	w -= obj.offsetWidth;
	w = w / 2;
	obj.style.left = w + "px";
	
	var h = document.documentElement.clientHeight;
	h -= obj.offsetHeight;
	h = h / 2;
	obj.style.top = h + "px"
}
function OnLogout()
{
	plus.storage.setItem("username", "");
	plus.storage.setItem("password", "");
	document.location = "login.html";
}
function OpenPage(extras, page)
{
	var win = plus.webview.getWebviewById(page);
	if(win)
	{
		win.close();
	}
	page = "_www/view/" +page;
	mui.openWindow({
		url: page,
		id: page,
		extras:extras
	});
}
function OnShowSparePartDetail(sparePartID){
	mui.openWindow({
		url: "goodMarket/SparePartInfo.html",
	    id: "goodMarket/SparePartInfo.html",
	    extras:{
	      SparePartID: sparePartID
	    }
	});
}
function OnSearchGooditsSparePart(){
	plus.nativeUI.showWaiting("正在加载...");
	var sparePartName = document.getElementById("sparePartSearch").value;
	var p = Page.init({
		templateId: "SparePartListTemplate",
		contentId: "sparePartListContent",
		data:{
			sparePartName:sparePartName
		},
		callback: function(PageIndex,PageData){
			plus.nativeUI.closeWaiting();
			//加载产品图片
			var imgs = document.getElementsByClassName("sparePartImg");
			for(var i=0;i<imgs.length;i++){
				imgs[i].src = getServicePath(imgs[i].name);
			}
	},
		url: getServicePath('/mobile/getSparePartList.html')
	});
	Page.search(p);
}
function setKnowledge(){
	mui("#navPage")[0].style.display = "none";
	mui("#mapButton")[0].style.display = "block";
	mui("#switchButton")[0].style.display = "none";
	mui("#lbTitle")[0].innerHTML = "法律法规";
	ajaxLoadHtml("assitant/KnowlegeType_anju.html", "content", function() {
		//mui.previewImage();
		OnSearchKnowledgeType();
		setContentHeight();
	});
}

function OnSearchKnowledgeType(){
	var p;
	var pageTemplate = new Template();

	plus.nativeUI.showWaiting("正在加载...");
	win = plus.webview.currentWebview();
	if(win.typename)
		mui("#lbTitle")[0].innerHTML = win.typename;
	var parentid = win.parentid;
	if(!parentid)
		parentid = 0;
	plus.nativeUI.showWaiting("正在加载...");
	var p = Page.init({
		templatePageUrl:"../data/tpl/page.tpl",
		templateId:"KnowlegeTypeListTemplate",
		contentId: "content",
		callback: function(data1,data){
			plus.nativeUI.closeWaiting();
		},
		url: getServicePath("/mobile/KnowledgeType/Search.html?" + parentid + "-")
	});
	Page.search(p);
}

function showKnowlegeType(typename,parentid){
	var url = "assitant/KnowlegeType.html";
	var id = "assitant/KnowlegeType1.html";
	if(win.id == "assitant/KnowlegeType1.html")
	{
		url = "assitant/KnowlegeType1.html";
		id = "assitant/KnowlegeType.html";
	}
	/*var win1 = plus.webview.getWebviewById(id);
	if(win1)
	{
		win1.close();
	}*/
	setTimeout(function(){
		mui.openWindow({
			url: url,
			id: id,
			extras:{
		    typename:typename,parentid:parentid
			}
		});
	}, 300);
}

function showKnowlege(typename,knowledgetypeid)
{
	
	setTimeout(function(){
		mui.openWindow({
			url: "assitant/Knowlege_v1.1.html",
			id: "assitant/Knowlege_v1.1.html",
			extras:{
		    	typename:typename,
		    	knowledgetypeid:knowledgetypeid
			}
		});
	}, 300);
	
}