function setMyRepairsContent() {
	mui("#lbback")[0].style.display="none";
	mui("#lbTitle")[0].innerHTML="应急安全-客户版";
	mui("#navPage")[0].style.display = "none";
	mui("#bar_tabs")[0].style.display="";
	if (!customerid)
		customerid = JSON.parse(getStorageValueByKey("loginUser"))["customerid"];
	ajaxLoadHtml("myrepairs/my_repairs.html", "content", function() {
		ajaxJsonByKey("getServiceRepairsStates", {
			CustomerID: customerid
		}, function(data) {
			serviceRepairsStates = data;
			if (parseInt(data["notassignmentnum"]) != 0)
				mui("#not_alone")[0].getElementsByTagName("a")[0].innerHTML += "<span class=\"mui-badge mui-badge-primary\">" + parseInt(data["notassignmentnum"]) + "</span>";
			if (parseInt(data["assignmentnum"]) != 0)
				mui("#already_alone")[0].getElementsByTagName("a")[0].innerHTML += "<span class=\"mui-badge mui-badge-primary\">" + parseInt(data["assignmentnum"]) + "</span>";
			if (parseInt(data["servicingnum"]) != 0)
				mui("#serviceing")[0].getElementsByTagName("a")[0].innerHTML += "<span class=\"mui-badge mui-badge-primary\">" + parseInt(data["servicingnum"]) + "</span>";
			if (parseInt(data["completednum"]) != 0)
				mui("#compelte")[0].getElementsByTagName("a")[0].innerHTML += "<span class=\"mui-badge mui-badge-primary\">" + parseInt(data["completednum"]) + "</span>";
			if (parseInt(data["evalutionnum"]) != 0)
				mui("#evalution")[0].getElementsByTagName("a")[0].innerHTML += "<span class=\"mui-badge mui-badge-primary\">" + parseInt(data["evalutionnum"]) + "</span>";
		})
		addMyRepairsElementListener();
	});
	setContentHeight();
}

function addMyRepairsElementListener() {
	mui(".mui-table-view-cell").each(function(index, obj) {
		obj.addEventListener("tap", function(event) {
			if(obj.id != "complain"){
				plus.nativeUI.showWaiting("正在加载...");
				setTimeout(function(){
					plus.nativeUI.closeWaiting();
						console.log(obj.id);
					if (obj.id == "not_alone") {
						setServiceRepairStates(customerid, serviceRepairsStates["notassignmentrepairids"], 1);
					} else if (obj.id == "already_alone") {
						setServiceRepairStates(customerid, serviceRepairsStates["assignmentrepairids"], 2);
					} else if (obj.id == "serviceing") {
						setServiceRepairStates(customerid, serviceRepairsStates["servicingrepairids"], 3);
					} else if (obj.id == "compelte") {
						setServiceRepairStates(customerid, serviceRepairsStates["completedrepairids"], 4);
					} else if (obj.id == "evalution") {
						//setServiceEvaluations(customerid);
						console.log("evaluation");
						setServiceRepairStates(customerid, serviceRepairsStates["evalutionrepairids"], 5);
					} 
				},800);
			}
		});
	});
}

function setServiceRepairStates(customerid, repairIds, type) {
	var muititle=mui("#lbTitle")[0];
	mui("#lbback")[0].style.display="";
	mui("#lbback")[0].onclick=function(){
		setMyRepairsContent();
	};
	mui("#navPage")[0].style.marginBottom="0px";
	mui("#bar_tabs")[0].style.display="none";
	switch (type){
		case 1:
			muititle.innerHTML="我的申请-未派单";
			break;
		case 2:
			muititle.innerHTML="我的申请-已派单";
			break;
		case 3:
			muititle.innerHTML="我的申请-服务中";
			break;
		case 4:
			muititle.innerHTML="我的申请-未评价";
			break;
		case 5:
			muititle.innerHTML="我的申请-已评价";
			break;
	}
	var p = Page.init({
		templatePageUrl: "../data/tpl/page.tpl",
		templateUrl: "myrepairs/service_state.html",
		PageSize: 15,
		pageId: "pages",
		contentId: "content",
		callback: function(PageIndex, PageData) {
			if(PageData["total"]>0)
				mui("#navPage")[0].style.display = "block";
			else{
				mui("#navPage")[0].style.display = "none";
				mui("#noDataDiv")[0].style.height=document.documentElement.clientHeight-95+"px";
			}
			setTimeout(setContentHeight, 500);
		},
		url: getServicePath("mobile/getServiceRepairsList.html")
	});
	Page.search(p, null, null, {
		CustomerID: customerid,
		repairIds: repairIds,
		type: type
	});
}
function setServiceEvaluations(customerid) {
	mui("#lbback")[0].style.display="";
	mui("#lbback")[0].onclick=function(){
		setMyRepairsContent();
	};
	mui("#navPage")[0].style.marginBottom="0px";
	mui("#bar_tabs")[0].style.display="none";
	mui("#lbTitle")[0].innerHTML="服务评价";
	var p = Page.init({
		templatePageUrl: "../data/tpl/page.tpl",
		templateUrl: "myrepairs/service_evaluation.html",
		PageSize: 15,
		pageId: "pages",
		contentId: "content",
		callback: function(PageIndex, PageData) {
			if(PageData["total"]>0)
				mui("#navPage")[0].style.display = "block";
			else{
				mui("#navPage")[0].style.display = "none";
				mui("#noDataDiv")[0].style.height=document.documentElement.clientHeight-95+"px";
			}
			setTimeout(setContentHeight, 500);
		},
		url: getServicePath("mobile/getServiceEvaluationList.html")
	});
	Page.search(p, null, null, {
		CustomerID: customerid
	});
}

//点击某一条，跳转到明细页面
function OnWorkBillDetail(id)
{
	var win = plus.webview.getWebviewById( "DispatchBillDetail.html" );
	if(win)
	{
		win.close();
	}
	page = "_www/view/myrepairs/DispatchBillDetail.html";
	mui.openWindow({
		url: page,
		id: "DispatchBillDetail.html",
		extras:{
		    DispatchID: id
		}
	});
}